SystemOrganization addCategory: #Heladeria!

TestCase subclass: #TestHelados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:24'!
agregarBao: unEnvase
|unHelado|
unHelado := BanioChocolate new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:10'!
agregarGusto: unGusto a: unEnvase
unEnvase agregarGusto: unGusto.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:48'!
agregarLicor: unEnvase
|unHelado|
unHelado := LicorNacional new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:48'!
agregarTopping: unEnvase
|unHelado|
unHelado := ToppingRegular new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingEspecial: unEnvase
|unHelado|
unHelado := ToppingEspecial new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingPremium: unEnvase
|unHelado|
unHelado := ToppingPremium new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:53'!
agregarToppingRegular: unEnvase
|unHelado|
unHelado := ToppingRegular new.
unHelado decorar: unEnvase.
^unHelado.! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:54'!
test01UnCucuruchoSinGustosNoEsValido
|unCucurucho|
unCucurucho := Cucurucho nuevo.
self deny: (unCucurucho valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:01'!
test02UnPoteDeCuartoSinGustosNoEsValido
|unHelado|
unHelado := PoteCuarto nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:02'!
test03UnPoteDeMedioSinGustosNoEsValido
|unHelado|
unHelado := PoteMedio  nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:02'!
test04UnPoteDeKiloSinGustosNoEsValido
|unHelado|
unHelado := PoteKilo  nuevo.
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:09'!
test05UnVasoSinGustosNoEsValido
|unHelado|
unHelado := Vaso nuevo initialize .
self deny: (unHelado valido)
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:09'!
test06UnCucuruchoCon1GustoEsValido
|unHelado|
unHelado:= Cucurucho nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self assert: (unHelado valido).
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:40'!
test07UnCucuruchoCon2GustosEsValido
|unHelado|
unHelado:= Cucurucho nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Chocolate new) a: unHelado. 
self assert: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:11'!
test08UnCucuruchoCon3GustosNoEsValido
| unHelado |
unHelado:= Cucurucho nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self deny:(unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:18'!
test09UnVasoCon1GustoEsValido
|unHelado|
unHelado:= Vaso nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self assert: (unHelado valido).
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:18'!
test10UnVasoCon2GustosEsValido
|unHelado|
unHelado:= Vaso nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self assert: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 14:55'!
test11UnPoteCon3GustosEsValido! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:19'!
test12UnPoteCon1GustoEsValido
|unHelado|
unHelado:= PoteKilo nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self assert: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:19'!
test13UnPoteCon2GustosEsValido
|unHelado|
unHelado:= PoteKilo nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado.
self assert: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:20'!
test14UnPoteCon3GustosEsValido
|unHelado|
unHelado:= PoteKilo nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado.
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self assert: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:23'!
test15UnPoteCon4GustosNoEsValido
|unHelado|
unHelado:= PoteKilo nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado.
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
self deny:(unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:04'!
test16UnPoteCon2ToppingsNoEsValido
|unHelado|
unHelado:= PoteKilo  nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingRegular: unHelado.
self deny:  (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:05'!
test17UnVasoCon2ToppingsNoEsValido
|unHelado|
unHelado:= Vaso  nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingRegular: unHelado.
self deny:   (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:05'!
test18UnCucuruchoCon2ToppingsNoEsValido
|unHelado|
unHelado:= Cucurucho   nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self deny:   (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:05'!
test19UnCucuruchoCon1ToppingsNoEsValido
|unHelado|
unHelado:= Cucurucho   nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self deny:   (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:05'!
test20UnVasoCon1ToppingsNoEsValido
|unHelado|
unHelado:= Vaso   nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self deny:   (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:21'!
test21UnPoteCon1ToppingsNoEsValido
|unHelado|
unHelado:= PoteKilo nuevo initialize .
unHelado := PreparadorDeHelados instance  agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance  agregarToppingEspecial: unHelado.
self deny: (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:05'!
test22UnPoteCon3ToppingsEsValido
|unHelado|
unHelado:= PoteKilo  nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self assert:  (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:08'!
test23UnVasoCon3ToppingsEsValido
|unHelado|
unHelado:= Vaso   nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self assert:  (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:08'!
test24UnCucuruchoCon3ToppingsEsValido
|unHelado|
unHelado:= Cucurucho   nuevo initialize .
unHelado := PreparadorDeHelados new agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados new agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados new agregarToppingEspecial: unHelado.
self assert:  (unHelado valido).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:08'!
test25UnCucuruchoConLicorTieneToppings
|unHelado|
unHelado:= Cucurucho   nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarLicorImportado: unHelado .
self assert:  (unHelado valido  ).
self assert: unHelado validateTopping 
! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:09'!
test26UnVasoConLicorTieneToppings
|unHelado|
unHelado:= Vaso   nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarLicorImportado: unHelado .
self assert:  (unHelado valido  ).
self assert: unHelado validateTopping ! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:09'!
test27UnPoteConLicorTieneToppings
|unHelado|
unHelado:= PoteKilo   nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingRegular: unHelado.
unHelado := PreparadorDeHelados instance agregarToppingEspecial: unHelado.
unHelado := PreparadorDeHelados instance agregarLicorImportado: unHelado .
self assert:  (unHelado valido  ).
self assert: unHelado validateTopping ! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:10'!
test28UnPoteConBaoNoEsValido
|unHelado|
unHelado:= PoteKilo   nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance baar:  unHelado.
self deny: (unHelado valido )! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:16'!
test29UnCucuruchoConBaoNoTieneToppings
|unHelado|
unHelado:= Cucurucho nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance baar:  unHelado.
self deny:   (unHelado validateTopping )! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:11'!
test30UnVasoConBaoNoTieneToppings
|unHelado|
unHelado:= Vaso nuevo initialize .
unHelado := PreparadorDeHelados instance agregarGusto: (Vainilla new) a: unHelado. 
unHelado := PreparadorDeHelados instance baar:  unHelado.
self deny:   (unHelado validateTopping )! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:37'!
test31UnVasoCuesta5Pesos
|unHelado|
unHelado:= Vaso nuevo initialize .
self assert: (5 pesos = 5 pesos ).! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:02'!
test32UnCucuruchoCuesta10Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:02'!
test33UnPoteDeCuartoCuesta20Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test34UnPoteDeMedioCuesta35Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test35UnPoteDeKiloCuesta65Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:03'!
test36LicorNacionalCuesta6Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:04'!
test37LicorImportadoCuesta10Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test38BaoChocolateCuesta5Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test39ToppingRegularCuesta1Peso! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test40ToppingEspecialCuesta3Pesos! !

!TestHelados methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:05'!
test41ToppingPremiumCuesta5Pesos! !

Object subclass: #ComponenteDeHelado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!ComponenteDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:42'!
agregarGusto: aVainilla 
	(self puedeAgregarGusto:aVainilla)
	ifTrue: [aVainilla decorar: self. aVainilla setValido]
	ifFalse: [aVainilla decorar: self. aVainilla noValido.]
 
	! !

!ComponenteDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:26'!
precio
^self subclassResponsibility.! !

ComponenteDeHelado subclass: #DecoradorDeHelado
	instanceVariableNames: 'decorado precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

DecoradorDeHelado subclass: #BanioChocolate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:25'!
decorar: unEnvase
decorado := unEnvase.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:13'!
noValido
	decorado noValido.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:26'!
precio
^ precio + decorado precio.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:44'!
puedeAgregarGusto: aChocolate 
^decorado puedeAgregarGusto: aChocolate.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:47'!
puedeAgregarLicor
	^decorado puedeAgregarLicor: 3.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:42'!
puedeAgregarLicor: aSmallInteger 
	^decorado puedeAgregarLicor: aSmallInteger.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 18:02'!
setValido
	decorado setValido .! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 18:03'!
validate
	(self validateTopping)
	ifTrue: [self setValido]
	ifFalse: [self noValido].
	(self validateBanio )
	ifTrue: [self setValido]  ifFalse: [self noValido].
	(self validateLicor)
	ifTrue: [self setValido ] ifFalse: [self noValido ].! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:13'!
validateBanio
	^decorado validateBanio.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:29'!
validateLicor
	(self validateTopping)
	ifTrue: [^decorado validateLicor: 0.]
	ifFalse: [self noValido. ^false]! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:27'!
validateLicor: aSmallInteger 
	^decorado validateLicor: aSmallInteger.! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:47'!
validateTopping
	decorado noValido.
 	^decorado validateTopping: 3! !

!DecoradorDeHelado methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 18:30'!
valido
	^decorado valido.! !

DecoradorDeHelado subclass: #Gusto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Gusto subclass: #Chocolate
	instanceVariableNames: 'nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Gusto methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:21'!
precio: aPesos 
	precio:= aPesos.! !

!Gusto methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 00:41'!
puedeAgregarTopping: aToppingEspecial 
	decorado puedeAgregarTopping: aToppingEspecial.! !

!Gusto methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 00:56'!
validateTopping: aSmallInteger 
	^decorado validateTopping: aSmallInteger.! !

Gusto subclass: #NoGusto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Gusto subclass: #Vainilla
	instanceVariableNames: ''
	classVariableNames: 'nombre'
	poolDictionaries: ''
	category: 'Heladeria'!

Vainilla class
	instanceVariableNames: 'precio'!

Vainilla class
	instanceVariableNames: 'precio'!

!Vainilla class methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:16'!
nuevo
|unGusto|
unGusto := Vainilla new.
unGusto 	precio: 0 pesos.
	^unGusto.
	! !

DecoradorDeHelado subclass: #Licor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Licor methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:15'!
validateBanio 
decorado noValido.! !

!Licor methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 01:28'!
validateLicor: aSmallInteger 
	^false.! !

Licor subclass: #LicorImportado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Licor subclass: #LicorNacional
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

DecoradorDeHelado subclass: #Topping
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Topping class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:41'!
validateTopping
	self shouldBeImplemented.! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:49'!
puedeAgregarLicor
	^decorado puedeAgregarLicor: 2! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:49'!
puedeAgregarLicor: aSmallInteger 
	^decorado puedeAgregarLicor: aSmallInteger -1! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:49'!
puedeAgregarTopping: aTopping
	^decorado puedeAgregarTopping: aTopping.! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:15'!
validateBanio
	decorado noValido ! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:22'!
validateTopping
	decorado noValido.
 	(decorado validateTopping: 2) ifTrue: [decorado  setValido ].! !

!Topping methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 00:56'!
validateTopping: aSmallInteger 
^decorado validateTopping: aSmallInteger-1! !

Topping subclass: #ToppingEspecial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Topping subclass: #ToppingPremium
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Topping subclass: #ToppingRegular
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

ToppingRegular class
	instanceVariableNames: 'precio'!

ToppingRegular class
	instanceVariableNames: 'precio'!

!ToppingRegular class methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:24'!
nuevo
|asd|
asd := ToppingRegular new
asd setPrecio: 5.
^asd.! !

!ToppingRegular methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:20'!
precio
^precio + decorado precio! !

ComponenteDeHelado subclass: #Envase
	instanceVariableNames: 'estadoValido cantidadGustos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

Envase subclass: #Cucurucho
	instanceVariableNames: 'gusto1 gusto2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Cucurucho class methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:56'!
deVainillaYChocolate
|unCucurucho|
unCucurucho:=Cucurucho new.
unCucurucho gusto1: Vainilla new.
unCucurucho gusto2: Chocolate new.
^unCucurucho.! !

!Cucurucho class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:07'!
nuevo
	^Cucurucho new noValido initialize.! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:58'!
gusto1: aVainilla 
	gusto1 := aVainilla! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 13:58'!
gusto2: aChocolate 
	gusto2 := aChocolate! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:06'!
initialize
cantidadGustos:= 2.! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:57'!
noValido
	self valido: NoValido new.! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^10 pesos! !

!Cucurucho methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:58'!
valido: aNoValido 
	estadoValido:= aNoValido .! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:04'!
noValido
	self valido: NoValido new.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'Anonymous 10/8/2012 15:27'!
precio
^self subclassResponsibility.! !

!Envase methodsFor: 'heladeria' stamp: 'juan 11/27/2012 17:04'!
puedeAgregarGusto: aVainilla 
	cantidadGustos := cantidadGustos -1.
	(cantidadGustos >= 0)
	ifTrue:[^true] ifFalse: [^false]! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:44'!
puedeAgregarLicor: aSmallInteger 
	(aSmallInteger == 0)
	ifTrue: [^true] ifFalse: [^false]! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 00:52'!
puedeAgregarTopping: aToppingEspecial 
	^true.
	! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 18:05'!
validateBanio
	^true.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 09:52'!
validateLicor: aSmallInteger 
	(aSmallInteger == 0)
	ifTrue: [^true] ifFalse: [ ^false]! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 18:27'!
validateTopping: aSmallInteger 
	(aSmallInteger == 0)
	ifTrue: [^true ] ifFalse: [^false ]! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:56'!
valido
	^estadoValido valor.! !

!Envase methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:04'!
valido: aNoValido 
	estadoValido:= aNoValido .! !

Envase subclass: #Pote
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Pote methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:07'!
initialize 
cantidadGustos := 3.! !

!Pote methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:15'!
validateBanio
	self noValido ! !

Pote subclass: #PoteCuarto
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteCuarto class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:08'!
nuevo
	^PoteCuarto new noValido initialize.! !

!PoteCuarto methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:16'!
precio
^20 pesos! !

Pote subclass: #PoteKilo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteKilo class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:09'!
nuevo
	^PoteKilo  new noValido initialize .! !

!PoteKilo methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^65 pesos! !

Pote subclass: #PoteMedio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!PoteMedio class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:09'!
nuevo
	^PoteMedio  new noValido initialize .! !

!PoteMedio methodsFor: 'as yet unclassified' stamp: 'juan 10/8/2012 16:18'!
precio
^35 pesos! !

Envase subclass: #Vaso
	instanceVariableNames: 'precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!Vaso class methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:22'!
nuevo
	^Vaso new noValido precio: 5 pesos.! !

!Vaso methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 17:07'!
initialize 
cantidadGustos := 2.! !

!Vaso methodsFor: 'as yet unclassified' stamp: 'juan 11/29/2012 17:28'!
precio
^precio.! !

Object subclass: #NoValido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

!NoValido methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 15:59'!
valor
	^false.! !

Object subclass: #PreparadorDeHelados
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!

PreparadorDeHelados class
	instanceVariableNames: 'instance'!

PreparadorDeHelados class
	instanceVariableNames: 'instance'!

!PreparadorDeHelados class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:45'!
instance
	instance ifNil:[instance:=super new].
	^instance.! !

!PreparadorDeHelados class methodsFor: 'as yet unclassified' stamp: 'juan 11/27/2012 16:46'!
new
^self instance. ! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 00:39'!
agregarGusto: unGusto a: unHelado 
unHelado agregarGusto: unGusto.
^unGusto  ! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:20'!
agregarLicorImportado: unHelado
| unLicor |
unLicor:=LicorImportado new.
(unHelado puedeAgregarLicor)
ifTrue: [unLicor decorar: unHelado. unLicor validateLicor.unLicor  setValido  . ^unLicor]

! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:02'!
agregarLicorNacional: unHelado
| unLicor |
unLicor:=LicorNacional  new.
(unHelado puedeAgregarLicor)
ifTrue: [unLicor decorar: unHelado. unLicor validateLicor  . ^unLicor]! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:02'!
agregarToppingEspecial: unHelado
| unToppingEspecial |
unToppingEspecial := ToppingEspecial new.
unHelado puedeAgregarTopping: unToppingEspecial.
unToppingEspecial decorar: unHelado.
unToppingEspecial validateTopping.
^unToppingEspecial.! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:02'!
agregarToppingPremium: unHelado
| unToppingEspecial |
unToppingEspecial := ToppingPremium  new.
unHelado puedeAgregarTopping: unToppingEspecial.
unToppingEspecial decorar: unHelado.
unToppingEspecial validateTopping.
^unToppingEspecial.! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:02'!
agregarToppingRegular: unHelado
| unToppingEspecial |
unToppingEspecial := ToppingRegular new.
unHelado puedeAgregarTopping: unToppingEspecial.
unToppingEspecial decorar: unHelado .
unToppingEspecial validateTopping .
^unToppingEspecial.! !

!PreparadorDeHelados methodsFor: 'as yet unclassified' stamp: 'juan 11/28/2012 10:04'!
baar: unHelado
| unBanio|
unBanio := BanioChocolate new.
unBanio decorar: unHelado.
unBanio validateBanio .
^unHelado.! !

Object subclass: #Valido
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Heladeria'!
